<?php

/**
 * @file
 * Contains composition.page.inc.
 *
 * Page callback for Composition entities.
 */

use Drupal\Core\Render\Element;

/**
 * Prepares variables for Composition templates.
 *
 * Default template: composition.html.twig.
 *
 * @param array $variables
 *   An associative array containing:
 *   - elements: An associative array containing the user information and any
 *   - attributes: HTML attributes for the containing element.
 */
function template_preprocess_composition(array &$variables) {
  // dpm($variables);
  // Fetch Composition Entity Object.
  $composition = $variables['elements']['#composition'];

  // Helpful $content variable for templates.
  foreach (Element::children($variables['elements']) as $key) {
    $variables['content'][$key] = $variables['elements'][$key];
  }
}
